<template>
  <div>
    <AdressItem
      :address="addressState.addressList.from"
      @update="addressState.addressToEdit = 'from'"
      @search="searchAddress(addressState.addressList.from)"
    ></AdressItem>
    <br />
    <AdressItem
      :address="addressState.addressList.to"
      @update="addressState.addressToEdit = 'to'"
      @search="searchAddress(addressState.addressList.to)"
    ></AdressItem>
    <br />

    <AddressForm
      v-if="addressState.addressToEdit"
      :label="addressState.addressList[addressState.addressToEdit].label"
      v-model:address="addressState.addressList[addressState.addressToEdit]"
      v-model:road="addressState.addressList[addressState.addressToEdit].road"
      v-model:zipCode="
        addressState.addressList[addressState.addressToEdit].zipCode
      "
      v-model:city="addressState.addressList[addressState.addressToEdit].city"
      v-model:complement="
        addressState.addressList[addressState.addressToEdit].complement
      "
      v-model:country="
        addressState.addressList[addressState.addressToEdit].country
      "
      v-model:state="addressState.addressList[addressState.addressToEdit].state"
      @close="addressState.addressToEdit = null"
    ></AddressForm>

    Number of results : {{ coordinatesLength }} {{ coordinatesLengthFromStore }}

    <AddressResult
      v-if="
        !searchStoreState.loading && searchStoreState.coordinates.length > 0
      "
      :coordinates="searchStoreState.coordinates"
      @select="searchStoreState.currentCoordinate = $event"
    ></AddressResult>

    <div
      v-else-if="
        !searchStoreState.loading && searchStoreState.coordinates.length === 0
      "
    >
      Aucun résultat de recherche...
    </div>
    <div v-else>Loading...</div>

    <CarteLeaflet
      :coordinates="searchStoreState.coordinates"
      :currentCoordinate="searchStoreState.currentCoordinate"
      :jsonData="state.gardens"
      v-model="state.bbox"
    >
      <template v-slot:popup>
        <div v-if="searchStoreState.currentCoordinate">
          {{ searchStoreState.currentCoordinate.properties.context }}<br />
          {{ searchStoreState.currentCoordinate.properties.label }}
        </div>
        <div v-else>Aucune adresse sélectionnée.</div>
      </template>
    </CarteLeaflet>

    <button @click="searchGarden">Charger espaces verts</button>
  </div>
</template>

<script setup>
import { reactive, computed } from "vue";
import { useRoute } from "vue-router";

import AdressItem from "../components/AddressItem.vue";
import AddressForm from "../components/AddressForm.vue";
import AddressResult from "../components/AddressResult.vue";
import CarteLeaflet from "../components/CarteLeaflet.vue";
import { getOverpassData } from "../services/overpass";
import { useSearchStore } from "../stores/search";
import { useAddress } from "@/composables/useAddress";

const searchStore = useSearchStore();
const { state: addressState } = useAddress();

const searchStoreState = searchStore.state;

const state = reactive({
  gardens: [],
  bbox: null,
});

const coordinatesLength = computed(() => searchStore?.coordinates?.length);
const coordinatesLengthFromStore = computed(
  () => searchStore?.coordinatesLength
);

const searchAddress = searchStore.searchAddress;

async function searchGarden() {
  const data = await getOverpassData(state.bbox);
  state.gardens = data;
}

const currentRoute = useRoute();

if (currentRoute.params.address) {
  addressState.addressList.from = JSON.parse(currentRoute.params.address);
}
if (addressState.addressList.from) {
  searchAddress(addressState.addressList.from);
}
</script>
